package edu.unca.csci235;

public class Collatz {

    static int collatz(int n) {
        int count = 0 ;
        while (n != 1) {
            if (n % 2 == 0) {
                n = n / 2 ;
            } else {
                n = 3 * n + 1 ;
            }
            count = count + 1 ;
        }
        return count ;
    }

    static void fill_collatz_table(int[] table) {
        if (table.length<1) {
            return ;
        }
        table[0] = 0 ;
        for(int i=1; i<table.length; ++i) {
            // You could do better if you passed the table!
            table[i] = collatz(i) ;
        }
    }

    static void print_table(int[] table) {
        for(int i=1; i<table.length; ++i) {
            System.out.printf("%4d --> %8d\n", i, table[i]) ;
        }
    }

    public static void main(String[] args) {
        int[] table = new int[200]  ;
        fill_collatz_table(table) ;
        print_table(table) ;
    }
    
}
